<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBoardingPassNumberResult ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBoardingPassNumberResult
 * @subpackage Arrays
 */
class ArrayOfBoardingPassNumberResult extends AbstractStructArrayBase
{
    /**
     * The BoardingPassNumberResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BoardingPassNumberResult[]
     */
    public $BoardingPassNumberResult;
    /**
     * Constructor method for ArrayOfBoardingPassNumberResult
     * @uses ArrayOfBoardingPassNumberResult::setBoardingPassNumberResult()
     * @param \StructType\BoardingPassNumberResult[] $boardingPassNumberResult
     */
    public function __construct(array $boardingPassNumberResult = array())
    {
        $this
            ->setBoardingPassNumberResult($boardingPassNumberResult);
    }
    /**
     * Get BoardingPassNumberResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BoardingPassNumberResult[]|null
     */
    public function getBoardingPassNumberResult()
    {
        return isset($this->BoardingPassNumberResult) ? $this->BoardingPassNumberResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBoardingPassNumberResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBoardingPassNumberResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBoardingPassNumberResultForArrayConstraintsFromSetBoardingPassNumberResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBoardingPassNumberResultBoardingPassNumberResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfBoardingPassNumberResultBoardingPassNumberResultItem instanceof \StructType\BoardingPassNumberResult) {
                $invalidValues[] = is_object($arrayOfBoardingPassNumberResultBoardingPassNumberResultItem) ? get_class($arrayOfBoardingPassNumberResultBoardingPassNumberResultItem) : sprintf('%s(%s)', gettype($arrayOfBoardingPassNumberResultBoardingPassNumberResultItem), var_export($arrayOfBoardingPassNumberResultBoardingPassNumberResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BoardingPassNumberResult property can only contain items of type \StructType\BoardingPassNumberResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BoardingPassNumberResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BoardingPassNumberResult[] $boardingPassNumberResult
     * @return \ArrayType\ArrayOfBoardingPassNumberResult
     */
    public function setBoardingPassNumberResult(array $boardingPassNumberResult = array())
    {
        // validation for constraint: array
        if ('' !== ($boardingPassNumberResultArrayErrorMessage = self::validateBoardingPassNumberResultForArrayConstraintsFromSetBoardingPassNumberResult($boardingPassNumberResult))) {
            throw new \InvalidArgumentException($boardingPassNumberResultArrayErrorMessage, __LINE__);
        }
        if (is_null($boardingPassNumberResult) || (is_array($boardingPassNumberResult) && empty($boardingPassNumberResult))) {
            unset($this->BoardingPassNumberResult);
        } else {
            $this->BoardingPassNumberResult = $boardingPassNumberResult;
        }
        return $this;
    }
    /**
     * Add item to BoardingPassNumberResult value
     * @throws \InvalidArgumentException
     * @param \StructType\BoardingPassNumberResult $item
     * @return \ArrayType\ArrayOfBoardingPassNumberResult
     */
    public function addToBoardingPassNumberResult(\StructType\BoardingPassNumberResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BoardingPassNumberResult) {
            throw new \InvalidArgumentException(sprintf('The BoardingPassNumberResult property can only contain items of type \StructType\BoardingPassNumberResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BoardingPassNumberResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BoardingPassNumberResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BoardingPassNumberResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BoardingPassNumberResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BoardingPassNumberResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BoardingPassNumberResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BoardingPassNumberResult
     */
    public function getAttributeName()
    {
        return 'BoardingPassNumberResult';
    }
}
