<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Board ServiceType
 * @subpackage Services
 */
class Board extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named BoardOffLoadPassengers
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\BoardOffLoadPassengers $parameters
     * @return \StructType\BoardOffLoadPassengersResponse|bool
     */
    public function BoardOffLoadPassengers(\StructType\BoardOffLoadPassengers $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->BoardOffLoadPassengers($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\BoardOffLoadPassengersResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
